---
title: Danger - Reference
subtitle: Reference
layout: layout_js
---

css:
  .attributes {
    margin-left: 10px;
  }

  article > code {
    display: block;
    width: 70%;
  }

  span.comment {
    color: grey;
  }

  hr {
    margin-top: 40px;
    margin-bottom: 20px;
  }

  .no-underline {
    text-decoration: none;
  }

  .examples {
    padding: 0;
  }

  .examples li {
    cursor: pointer;
    margin-left: 0;
    display: inline-block;
    width: 45%;
    user-select: none;
  }

   .examples li:hover {
    background: #eee;
  }

ruby:
  dsl = JSON.parse(File.read("json_data/js_dsl.json"))

  interfaces = dsl.select { |c| c["kindString"] == "Interface" && c["comment"] }.reject { |c| c["name"].end_with?("JSONType") || c["name"].end_with?("CliArgs") }
  danger = interfaces.find { |c| c["name"] == "DangerDSLType" }
  exports = dsl.select { |c| c["kindString"] == "Function" || c["kindString"] == "Variable" }.select { |c| c['name'] != "console" && c['name'] != "results"  }.sort_by { |e| e['name'] }

  def link_modules(m)
    return "<a href ='#DangerDSLType'>danger</a>" if m == "danger"
    return "<a href ='#PerilDSL'>peril</a>"if m == "peril"
    m
  end

  def de_link(html)
      html.gsub(/\[.*\]\(.*\)/) do |txt|
       to_show = txt.match(/(\[.*\])/)[1].tr("[","").tr("]","")
       url = txt.match(/(\(.*\))/)[1].tr("(","").tr(")","")
       "<a href=\"#{url}\">#{to_show}</a>"
    end
  end

  def comment(att, prefix = "")
    # A `const x = () => ` has a different way of documenting
    if att["kindString"] == "Method" 
      att = att["signatures"].find { |s| s["kindString"] == "Call signature" }
    end

    return "" unless att["comment"] && ( att["comment"]["text"] || att["comment"]["shortText"])

    comments = [att["comment"]["shortText"], att["comment"]["text"]]
    safe_comments = comments.compact.map{ |c| de_link(c.gsub("<", "&lt;")) }.join("<br/><br/>// ").gsub("\n\n", "<br/><br/>//")
    "<span class='comment'>" + prefix + "// " + safe_comments + "</span>"
  end

  def params(att)
    att["signatures"].first["parameters"].map { |p| name(p) + ": " + show_type(p["type"])  }.join(", ")
  end

  def returns(att)
    type = att["signatures"][0]["type"]
    show_type(type)
  end

  def show_type(type)
    # Currently only BitBucketServerPRParticipant
    # which we can just use the first bit for
    if (type["intersection"]) 
      return show_single_type(type["intersection"]["types"][0])
    end

    if type["elementType"]
      element = type["elementType"]

      inside = show_single_type(element)

      if element["types"] && element["types"].length
        inside ||= show_type(element["types"][0])
      end

      if element["type"] == "reflection"
        inside = element["declaration"]["children"].map {|t| show_single_type(t)}.join(", ")
      end

      outside = link_type(type)
      if outside && inside
        return outside + "<" + inside + ">"
      else
        require 'pry'
        binding.pry
      end
    end

    # only one of these ATM, the asyncFunction, so let's cheat
    if type["type"] == "reflection"
      if type["declaration"] &&  type["declaration"]["kindString"] == "Type literal"
        if type["declaration"]["children"]
          # Bitbucket's sub-objs instead of separate interfaces
          return sub_obj_type(type["declaration"])

        elsif type["declaration"]["signatures"]
            # Peril's runTask
            return signatures(type["declaration"])
        else
          require 'pry'
          binding.pry
        end
      else
        return "Promise | Function with a single callback argument"
      end
    end

    show_single_type(type)
  end

  def sub_obj_type(declaration)
    internals = declaration["children"].map { |t| comment(t, "&nbsp;&nbsp;") + "<br/>&nbsp;&nbsp;" + name(t) + ": " + show_type(t["type"]) }.join(",<br/>")
    "{<br/><br/>" + internals + "<br/>}"
  end

  def inline_sub_obj_type(declaration)
    internals = declaration["children"].map { |t| comment(t, "&nbsp;&nbsp;") + "&nbsp;" + name(t) + ": " + show_type(t["type"]) }.join(", ")
    "{" + internals + "}"
  end

  def signatures(declaration)
    declaration["signatures"].map { |s| sig_params(s["parameters"]) }.join("")
  end

  def sig_params(parameters)
    parameters.map { |p| name(p) + ": " + show_single_type(p["type"]) }.join(", ")
  end

  def show_single_type(type)
    return inline_sub_obj_type(type["declaration"]) if type["type"] == "reflection"
    return type["types"].reject { |t| t["name"] == "undefined" }.map{ |t| link_type(t) }.join(" | ") if type["type"] == "union"
    return link_type(type) if type["name"] 
  end

  def link_type(type)
    return "any" if type["name"] == "BitBucketServerLinks"
    return "<a href='##{type["name"]}'>" + type["name"] + "</a>"  if type["type"] == "reference"
    return '"' + type['value'] + '"'  if type["type"] == "stringLiteral" 
    type["name"] || type["type"]
  end

  def name(thing)
    isOptional = thing["flags"] && thing["flags"]["isOptional"]
    q = isOptional ? "?" : ""
    thing['name'] + q
  end

  def fn(attribute)
    kind = attribute["kindString"]
    if kind == "Function" || kind == "Method"
      "#{name(attribute)}(#{params(attribute)}) => #{returns(attribute)}"
    elsif kind == "Property"
      "#{name(attribute)}: #{show_type(attribute["type"])}"
    else
      name(attribute)
    end
  end

== javascript_include_tag  "https://code.jquery.com/jquery-3.1.0.min.js"
== javascript_include_tag  "https://cdn.jsdelivr.net/npm/js-cookie@2/src/js.cookie.min.js"

section.guide
  article  
    p So what does danger export? Well:

    code
      pre
        = "import { " + exports.map { |d| link_modules(d["name"]) }.join(", ") + " } from 'danger'"

    markdown:

       Is the entire API for writing a Dangerfile. The interesting one is <code>danger</code>, so let's cover everything else first. Y'know - save the best for last. These other exports are mainly the ways in which you can communicate the status of your rules back to Danger.

      ## Communication

      These are functions which you use in rules to provide feedback during code review. Assuming Danger has access to write a comment, then `fail`, `warn`, `message` and `markdown` will report directly inline.

    code    
      - for export in exports.select { |e| e['kindString'] == "Function" && e['name'] != "schedule" }
        = comment(export["signatures"][0]) + "<br/>" + fn(export) + "<br/><br/>"

    p There's also <code>schedule</code> which is a bit of a special case. You can find out more from inside the guide <a href='/js/guides/the_dangerfile.html#async'>On the Dangerfile</a>. It helps you handle async code within your Dangerfile inside Peril.

    code    
      - for export in exports.select { |e| e['name'] == "schedule" }
        = comment(export["signatures"][0]) + "<br/>" + fn(export) + "<br/><br/>"

    markdown:
      ## The Danger DSL - Root Objects

      OK, great - so now let's look through the API. This is the data that Danger will provide so that you can build rules for your team culture.

    code 
      - for export in danger["children"]
        = comment(export) + "<br/>danger." + fn(export) + "<br/><br/>"
    

    markdown:
    
      ## All Types

      This is meant to be the API reference, so I'll leave the prose at this point. Below is every object inside the Danger DSL. You can jump between the objects by clicking on their types.

      I'd recommend first just having a quick browse to have an overview in your head. Then I'd recommend using [the editor](/js/editor.html) to actually write some code with auto-complete to get a sense of what the syntax feels like.

    ul.examples
      li#gh Hide GitHub
      li#bb Hide BitBucket

    javascript:

      const setupBB = () => {
        const hideBB = Cookies.get('hide_bb') == "true"; 
        if (hideBB) {
          $("section article > code[id^=BitB]").hide()
          $("#bb").text("Show BitBucket DSL")
        } else {
          $("section article > code[id^=BitB]").show()
          $("#bb").text("Hide BitBucket DSL")
        }
      }

      const setupGH = (prefix) => {
        const hideGH = Cookies.get('hide_gh') == "true"; 
        if (hideGH) {
          $("section article > code[id^=GitHub]").hide()
          $("#gh").text("Show GitHub DSL")
        } else {
          $("section article > code[id^=GitHub]").show()
          $("#gh").text("Hide GitHub DSL")
        }
      }

      $(() => {
        setupBB()
        setupGH()
        $("#bb").click((e) => {
          e.preventDefault()
          const hideBB = Cookies.get('hide_bb') == "true"; 
          console.log("togglin,", hideBB)
          Cookies.set('hide_bb', hideBB ? "false" : "true")
          setupBB()

        })

        $("#gh").click((e) => {
          e.preventDefault()

          const hideGH = Cookies.get('hide_gh') == "true"; 
          console.log("togglingh,", hideGH)
          Cookies.set('hide_gh', hideGH ? "false" : "true")
          setupGH()
        })
      })

    - for interface in interfaces
      code.reference id=interface["name"] 
        = comment(interface) + "<br/><br>"
        = "<a class='no-underline vibrant-dark' href='##{ interface["name"] }'>"
        = fn(interface) 
        = "</a>"
        = " {<br/><br/><div class='attributes'>"
          
        - if interface["children"]
          - for detail in interface["children"]
            == comment(detail) + "<br/>" + fn(detail) + "<br/><br/>"

        - if interface["indexSignature"]
          - for detail in interface["indexSignature"]
            == comment(detail) + "<br/>"

        = "</div>}"
        hr
